﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void SelectAll(string tablename, string startchar, SqlString numcols)
    {
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        using (SqlCommand cmd = new SqlCommand())

        try 
        {
            conn.Open();
            cmd.Connection = conn;

            cmd.CommandText = String.Format(@"
                SELECT count(*) from sys.columns 
                WHERE object_id = OBJECT_ID('{0}')
                AND is_sparse = 0", tablename);
            int nonsparse = (int)(cmd.ExecuteScalar());

            if (startchar.Contains("%"))
                cmd.CommandText = String.Format(@"
                SELECT TOP {0} name from sys.columns 
                WHERE object_id = OBJECT_ID('{1}')
                AND is_sparse = 1
                AND name LIKE '{2}'
                ORDER BY name", 4096 - nonsparse, tablename, startchar);
            else
                cmd.CommandText = String.Format(@"
                SELECT TOP {0} name from sys.columns 
                WHERE object_id = OBJECT_ID('{1}')
                AND is_sparse = 1
                AND name > '{2}'
                ORDER BY name", 4096 - nonsparse, tablename, startchar);

            SqlDataReader rdr = cmd.ExecuteReader();

            StringBuilder sb = new StringBuilder("select *", 50000);

            while (rdr.Read())
            {
                sb.AppendFormat(",{0}", rdr.GetString(0));
            }
            sb.AppendFormat(" from {0}", tablename);

            rdr.Close();

            cmd.CommandText = sb.ToString();
            SqlContext.Pipe.ExecuteAndSend(cmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
                                                
    }
};
