﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction]
    [return: SqlFacet(MaxSize = -1)]
    public static string SparseStringTab(string tablename, int numcols)
    {
        StringBuilder sb = new StringBuilder("create table ", 100 + 20 * numcols);

        sb.AppendFormat("{0} (id int primary key identity ", tablename);

        for (int i = 1; i <= numcols; i++)
        {
            sb.AppendFormat(",[col{0}] varchar(100) sparse", i);
        }
        sb.Append(",col_values xml column_set for all_sparse_columns);");

        return sb.ToString();
    }
};

