﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction]
    [return: SqlFacet(MaxSize = -1)]
    public static string PopulateSparse(string tablename, int numcols)
    {
        StringBuilder sb = new StringBuilder("insert ", 100 + 20 * numcols);

        sb.AppendFormat("{0} (", tablename);

        for (int i = 1; i < numcols; i++)
        {
            sb.AppendFormat("col{0},", i);
        }
        sb.AppendFormat("col{0}) values(", numcols);

        for (int i = 1; i < numcols; i++)
        {
            sb.AppendFormat("{0},", i);
        }

        sb.AppendFormat("4);", numcols);

        return sb.ToString();
    }
};

