﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Text;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction]
    public static string RandomInsert(string tablename, int numcols, int numtabcols)
    {
        Random rdm = new Random(~unchecked((int)DateTime.Now.Ticks)); 

        StringBuilder sb = new StringBuilder("insert ", 25*numcols);
        sb.AppendFormat("{0} (", tablename);

        for (int i = 1; i < numcols; i++)
        {
            sb.AppendFormat("col{0}, ", (int)(rdm.Next(1, numtabcols)));
        }
        sb.AppendFormat("col{0}) values(", (int)(rdm.Next(1, numtabcols)));

        for (int i = 1; i < numcols; i++)
            sb.AppendFormat("{0},", i);

        sb.Append("100);");

        return sb.ToString();

    }
};

